          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                     
                                            
Sec           equ         20h               ;    
Sec1          equ         21h      
t1L           equ         22h               ;   .  
t1H           equ         23h               ;   .  
t1LL          equ         24h               ; 
t1HH          equ         25h               ;  
tmp_off       equ         26h               ;  

flag          equ         7Dh               ;  
W_TEMP        equ         7Eh               ;     W
STATUS_TEMP   equ         7Fh               ;    STATUS
 
                                            ;   -
#DEFINE       serv        PORTB,4           ;   
#DEFINE       knp_1       PORTB,0           ; 1
#DEFINE       knp_2       PORTB,1           ; 2
 

   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                 
prov_tmr1     bcf         T1CON,TMR1ON      ;  TMR1
              btfsc       flag,0            ;  
              goto        t2                ;  (1):   t2
                                            
t1            movf        t1HH,W            ;   0:  
              movwf       TMR1H             ;      
              movf        t1LL,W            ;   TMR1
              movwf       TMR1L             ;
              bsf         flag,0            ;  
              bsf         serv              ;  1  / serv
              goto        extmr1            ;   extmr1

t2            bcf         serv              ;  0  / serv
              bcf         flag,0            ;  
              movlw       .183              ;    
              movwf       TMR1H             ;  18,5 
              movlw       .187              ;
              movwf       TMR1L             ;
              movlw       .24               ;     
              xorwf       tmp_off,W         ;
              btfss       STATUS,Z          ;
              goto        extmr2            ;    24:  extmr2
              bcf         PIR1,TMR1IF       ;   24:    
                                            ;  TMR1
              goto        exxit             ;   exxit 
extmr2        incf        tmp_off,F         ;   

extmr1        bcf         PIR1,TMR1IF       ;     TMR1
              bsf         T1CON,TMR1ON      ;  TMR1
                
exxit         swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                             
             
Start         clrf        PORTB             ;  PORTB 
              clrf        PORTA             ;  PORTA
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'11101111'       ;  \  B     
              movwf       TRISB             ;RB4  ,   
              bcf         STATUS,RP0        ; 0- 
           
              bcf         flag,0            ;  
              clrf        tmp_off           ;  

              movlw       .220              ;  (1,5 )  
              movwf       t1L               ;     
              comf        t1L,W             ;     
              movwf       t1LL

              movlw       .5
              movwf       t1H
              comf        t1H,W
              movwf       t1HH

              movlw       b'00000000'       ; . TMR1 1:1,    
              movwf       T1CON             ;  Fosc
              
              clrf        TMR1L             ;   TMR1
              clrf        TMR1H

              bsf         INTCON,PEIE       ;   
              bcf         PIR1,TMR1IF       ;     TMR1
              bsf         STATUS,RP0        ; 1- 
              bsf         PIE1,TMR1IE       ;    TMR1
              bcf         STATUS,RP0        ; 0-              
              bsf         T1CON,TMR1ON      ;  TMR1
              bsf         INTCON,GIE        ;           

opros_knp     btfsc       knp_1             ;  1
              goto        met_1             ; 1  :    met_1
              call        povorot_1         ; 1 :   povorot_1
              call        pausknp           ;  
              goto        opros_knp         ;   opros_knp
met_1         btfsc       knp_2             ;  2
              goto        met_2             ; 2  :    met_2
              call        povorot_2         ; 2 :   povorot_2
              call        pausknp           ;  
              goto        opros_knp         ;   opros_knp

met_2         call        vozvrat           ;     
              call        paus_vozvr        ;    
              goto        opros_knp         ;   opros_knp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;              

vozvrat       movlw       .5                ;   
              subwf       t1H,W             ;   
              btfss       STATUS,C          ;
              goto        uvel              ;  1,5    uvel

              btfss       STATUS,Z          ;
              goto        umen             ;  1,5,    umen 
              movlw       .220              ;
              subwf       t1L,W             ;
              btfss       STATUS,C          ;
              goto        uvel              ;  1,5,    uvel
              btfsc       STATUS,Z          ;
              return                        ;  1,5  ;   vozvrat 
                                            ;  1,5,    umen 
              
umen          movlw       .10               ;   
              subwf       t1L,F             ; 10 
              btfsc       STATUS,C          ;
              goto        umen_p12           ;
              decf        t1H,F             ;
umen_p12      call        perezap           ;  perezap
              return                        ;   vozvrat 
                   
uvel          movlw       .10               ;   
              addwf       t1L,F             ; 10 
              btfss       STATUS,C          ;
              goto        uvel_p22           ;
              incf        t1H,F             ;
uvel_p22      call        perezap           ;  perezap
              return                        ;   povorot_1
                  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                                            

povorot_1     movlw       .2                ;   
              subwf       t1H,W             ;   
              btfss       STATUS,C          ;
              return                        ;  600 ,    
                                            ;,    povorot_1
              btfss       STATUS,Z          ;
              goto        met_p11           ;  600 ,    met_p11 
              movlw       .88              ;
              subwf       t1L,W             ;
              btfss       STATUS,C          ;
              return                        ;  600 ,   
                                            ;,    povorot_1

met_p11       movlw       .10               ;   
              subwf       t1L,F             ; 10 
              btfsc       STATUS,C          ;
              goto        met_p12           ;
              decf        t1H,F             ;
met_p12       call        perezap           ;  perezap
              return                        ;   povorot_1

povorot_2     movf        t1H,W             ;   
              sublw       .9                ;  
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2 
              btfss       STATUS,Z          ;  
              goto        met_p21           ;  2,5 :    met_p21
              movf        t1L,W             ;
              sublw       .196             ;
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2

met_p21       movlw       .10               ;   
              addwf       t1L,F             ; 10 
              btfss       STATUS,C          ;
              goto        met_p22           ;
              incf        t1H,F             ;
met_p22       call        perezap           ;  perezap
              return                        ;   povorot_1

                                            ;
perezap       bsf         STATUS,RP0        ; 1- 
              bcf         PIE1,TMR1IE       ;    TMR1
              bcf         STATUS,RP0        ; 0- 
              comf        t1L,W             ;     
              movwf       t1LL              ;
              comf        t1H,W             ;
              movwf       t1HH              ;
              clrf        tmp_off           ;  
              bsf         T1CON,TMR1ON      ;  TMR1
              bsf         STATUS,RP0        ; 1- 
              bsf         PIE1,TMR1IE       ;    TMR1
              bcf         STATUS,RP0        ; 0- 
              return                        ;;   perezap

pausknp       movlw       .14               ;  10,5 
              movwf       Sec1              ;
p3            movlw       .250              ;
              movwf       Sec               ;
p2            decfsz      Sec,F             ;
              goto        p2                ;
              decfsz      Sec1,F            ;
              goto        p3                ;
              return                        ;

paus_vozvr    movlw       .14               ;  10,5 
              movwf       Sec1              ;
pp3           movlw       .250              ;
              movwf       Sec               ;
pp2           decfsz      Sec,F             ;
              goto        pp2                ;
              decfsz      Sec1,F            ;
              goto        pp3                ;
              return                        ;
                                            ;
	          end                           ;
                                            ;